/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#ifndef QUB_REPORTSTREAM_H
#define QUB_REPORTSTREAM_H

class mil_reportbuf : public std::streambuf
{
public:
	mil_reportbuf() : lineout( new ostrstream )
	{ setp(0,0), setg(0,0,0); }

	~mil_reportbuf() { delete lineout; }

	void setTarget( QTR_NodeFptr reportCB )
	{ callback = reportCB; }

protected:
	virtual int overflow( int ch );
private:
	QTR_NodeFptr callback;
	ostrstream *lineout;
};

class mil_reportstream : public std::ostream
{
public:
	mil_reportstream( QTR_NodeFptr reportCB )
		: std::basic_ostream<char,std::char_traits<char> >( new mil_reportbuf )
	{
		((mil_reportbuf *) rdbuf())->setTarget( reportCB );
	}
        virtual ~mil_reportstream()
        {
                delete rdbuf();
        }
};



#endif
